clear all; clc

%%% linear congruencial method

% small period
x = rndlc(40, 42, 5, 7, 200);
histogram(x, 20);

% large period
x = rndlc(5000, 42, 7^5-1, 0, 2^32-1);
histogram(x, 20);

% compare with 0.5, 1/12 = 0.083333
mean(x)
var(x) 

% check mean, var wrt n

k = 50:100:10000; % various sample sizes
x = rndlc(10000, 42, 7^5-1, 0, 2^32-1); % sampled values 
means = zeros(length(k), 1); % vector of means for the various sample sizes
vars = zeros(length(k), 1);  % vector of variances for the various sample sizes


for i = 1:length(k)
    
    means(i) = mean(x(1:k(i)));
    vars(i) = var(x(1:k(i)));
    
end


figure
subplot(2, 1, 1)
plot(k, means, 'Color', 'blue')
xL = get(gca,'XLim');
line(xL, [0.5 0.5],xL,'Color','red', 'LineWidth',1);
subplot(2, 1, 2)
plot(k, vars, 'Color', 'blue')
xL = get(gca,'XLim');
line(xL, [1/12 1/12],xL,'Color','red', 'LineWidth',1);

% plot distance from true value

mdists = abs(means - 0.5 * ones(length(k), 1));
vdists = abs(vars - 1/12 * ones(length(k), 1));

figure
subplot(2, 1, 1)
plot(k, mdists, 'Color', 'blue');
subplot(2, 1, 2)
plot(k, vdists, 'Color', 'blue');
  

%%% middle square method

x = rndms(1000, 1236);

histogram(x/10^4, 10)

