function [x] = rndms(n, seed)

% This function produces n random numbers using the Middle Square Method
% inputs: n is the number of the values to be produced, seed is the
% 4-digit starting number
% output: a column of n random numbers

x = zeros(n, 1); % initialize

m0 = 10^6;
m1 = 10^2;

temp = seed; % set seed to begin

for i = 1:n
    
    temp = temp ^ 2; % square to get 8-digit number
    
    temp = mod(temp, m0); % choose last 6 digits
    
    temp = temp - mod(temp, m1); % choose first 4 digits (followed by 2 zeros)
    
    x(i) = temp / m1; % divide with 100
    
    temp = x(i);
    
end
    

end
