function [x] = disrnd(n, probs)
% draw random sample from distribution with pmf
% p_i = P{x=i} = probs(i)

x = zeros(n, 1); % initialize

vals = 1:length(probs); % values of the support
c = cumsum(probs); % cumulative sum of probabilities

for i = 1:n
    
    u = rand; % draw uniform
    
    for j = 1:length(probs)
        
        if u <= c(j)     % accept
            x(i) = vals(j);
            break % end loop - proceed to next draw
        end
        
    end
            

end
